      subroutine skew_kurt(u,n,centroid,skew,curt)
      real skew, curt, u(n)
      integer n
      
      double precision sum, m1, m2, m3, m4
*      
      m1 = 0.0
      m2 = 0.0
      m3 = 0.0
      m4 = 0.0
      sum = 0.0
*
      amax = -1e9
      do 100 i = 1,n
         if(u(i) .gt. amax) amax = u(i)
100   continue
      cut_off = 0.2 * amax
*
*     compute the moments of the time function
*      
      do 1 i = 1, n
         if(u(i) .gt. cut_off)then
           m1 = m1 + u(i) * real(i-1)
	   sum = sum + u(i)
	 endif
1     continue
*
      if(sum .eq. 0.0)then
        skew = -1e6
	curt = skew
	return
      end if
*
      m1 = m1 / sum
*      
      do 2 i = 1, n
         m2 = m2 + u(i) * (real(i-1) - m1)**2
2     continue

      do 3 i = 1, n
         m3 = m3 + u(i) * (real(i-1) - m1)**3
3     continue
      
      do 4 i = 1, n
         m4 = m4 + u(i) * (real(i-1) - m1)**4
4     continue
*
      centroid = m1
      skew = m3 / (sqrt(m2)**3)
      curt = m4 / (m2*m2)
      
      return
      end
	 
*****************************************************************
*
*     Compute a Frequency Spectrum Centroid and peak location
*
*****************************************************************
      subroutine ampsp_centroid(s,n,centroid,peak,dt)
      real s(n), centroid, dt
      integer n
      real am_sp(14000)
      integer forward, inverse
      
      forward =  1
      inverse = -1
      
      n_over_2 = n / 2
      df = 1.0 / (real(n) * dt)
      freq = 0.0
      call realft(s,n_over_2,forward)
      
      smax = -1e9
      peak = 0.0
      am_sp(1) = sqrt(s(1)*s(1))
      do 1 i = 2,n_over_2
	 k = i * 2
	 freq = freq + df
	 am_sp(i) = sqrt(s(k-1)*s(k-1)+s(k)*s(k))
	 if(am_sp(i) .gt. smax) then
	   smax = am_sp(i)
	   peak = freq
	 end if
1     continue

      call skew_kurt(am_sp,n_over_2,centroid,skew,curt)
      centroid = centroid * df
      
      call realft(s,n_over_2,inverse)
      
      scalefactor = 2 * dt * df
      do 2 i = 1,n
        s(i) = scalefactor * s(i)
2     continue
      
      return
      end
*****************************************************************
*     Compute weighted average value of the function f
*
*     only a limited range of amplitudes are used
*       to minimize bias from noise
*****************************************************************
*
      subroutine wt_avg(f,a,n,dt,thevalue)
      real a(n), f(n), dt, thevalue
      integer n
      
      amax = -1e9
      do 100 i = 1,n
         if(a(i) .gt. amax) amax = a(i)
100   continue
      cut_off = 0.95 * amax
*
*     compute the moments of the time function
*      
      sum = 0.0
      thevalue = 0
      do 1 i = 1, n
         if(a(i) .gt. cut_off)then
	   thevalue = thevalue + f(i)*abs(a(i))
	   sum = sum + abs(a(i))
	 endif
1     continue
      thevalue = thevalue / sum
*
      return
      end
      
