*
      subroutine est_noise(period, amp,seis,npts,dt,beg,a_pick,halfpts,ok)
      parameter(mxpts = 8192 + 2)
      real period(mxpts), amp(mxpts), seis(npts)
      integer ok
*
      integer nfpts,halfpts,nyqpt,forward,inverse
      integer pgopen, stdin, stdout, mxpts
*
      real fnyquist, df, wwidth, tfraction, s(mxpts)
      
      character*1 key
*      
      ok = 1
      if(a_pick .eq. -12345)then 
      	ok = -1
	return
      end if
*       
      forward =  1
      inverse = -1 
      stdin = 5
      stdout = 6 
       
      do 5 i = 1,mxpts
         s(i) = 0
5     continue
    
*       
*********************************************************************************
*     window out the part of the signal in front of the P-wave
*     which is marked by the P-arrival stored in the SAC header
*     and which at this point is in the variable a_pick
*
*     Also, remove the mean and apply a Bartlett window the signal
*********************************************************************************
      nt = (a_pick - beg)/dt
      if(nt .gt. mxpts) nt = mxpts
      nh = nt / 2
      
      write(stdout,*)'Time Pick: ',a_pick
      write(stdout,*)'Estimating Noise with ', nt, ' points ('
     & ,nt*dt,'s).'

      do 8 i = 1,nt
         sum = sum + seis(i)
8     continue
      avg = sum / real(nt)
      
      do 10 i = 1,nt
         taper = 1 - (abs(nh - i + 1) / nh)
         s(i)  = taper * (seis(i)-avg)
10    continue
*       
*********************************************************************************
*     Compute parameters for Fourier Transform
*********************************************************************************
      nfpts = 1
50    nfpts = nfpts * 2
      if(nfpts .lt. nt) go to 50
*      
      if(nfpts .gt. mxpts)then
	write(stdout,*)'Problem in est_noise:'
	write(stdout,*)'Too many points in trace.'
	write(stdout,*)'  nfpts = ',nfpts,' mxpts = ',mxpts
	write(stdout,*)'RETURNING WITHOUT FILTERING'
	call pgslct(iold_dev)
	return
      end if
*
      halfpts = nfpts / 2
      fnyquist = 1 / (2*dt)
      nyqpt = halfpts
      df = 1.0 / (nfpts * dt)
*
*********************************************************************************
*     Transform the time series
*********************************************************************************
      call realft(s,halfpts,forward)
      scalefactor = dt
      do 60 i = 1, nfpts
        s(i) = s(i) * scalefactor
60    continue
*
*********************************************************************************
*     Compute the log10 of the Amplitude Spectrum and periods
*********************************************************************************

      amp(1) = sqrt(s(1)**2)
      period(1) = 1e9
      do 100 i = 2, halfpts
         amp(i) = log10(sqrt(s(2*i-1)*s(2*i-1)+s(2*i)*s(2*i)))
	 period(i) = log10(1 / ((i-1)*df))
100   continue
*
*********************************************************************************
*     Smooth the Amplitude Spectrum 
*********************************************************************************

      npasses = 2
      idum = halfpts - 1
      do 200 n=1,npasses
         amp(1) = 0.5*(amp(1)+amp(2))
	 do 150 i = 2,idum
	     amp(i) = 0.25*(amp(i-1)+2*amp(i)+amp(i+1))
150      continue
         amp(halfpts) = 0.5*(amp(idum)+amp(halfpts))      
200   continue


      return
      end      
      
*
