*		routine getseis for the surface wave codes
*
*     Chuck Ammon UC Santa Cruz
*     June, 1991 all rights reserved
*
      subroutine getseis()
      
      include 'swanalysis.h'  
           
      write(stdout,*) 'What is the sac file name?'
      read(stdin,*) seisfile
      
      call rsac1(seisfile,seis,ntpts,or_beg,dt,maxtpts,nerr)
      if(nerr .gt.0)then
        write(stdout,*) 'Problem reading in the seismogram.'
	stop
      end if
      
*     write(stdout,*) 'What is the source-receiver distance?'
*     read(stdin,*) distance
      call getfhv('DIST',distance,nerr)
*
      call getfhv('O',t0,nerr)
      call getfhv('A',a_pick,nerr)
*
      if(t0 .ne. -12345)then
         or_beg = or_beg - t0
      end if
      
      beg = 0.0
      end = dt * float(ntpts - 1)
      or_end = end + or_beg

      vgmax = 1e6
      vgmin = 0
      if(or_beg .gt. 0)then
        vgmax = distance / or_beg
      end if

      if(or_end .gt. 0)then
        vgmin = distance / or_end
      end if
      
      return
      end
      

*     routine getseis for the surface wave codes
*
*     Chuck Ammon UC Santa Cruz
*     June, 1991 all rights reserved
*
      subroutine fgetseis()
      
      include 'swanalysis.h' 
      
      nerr = 0 
           
c     write(stdout,*) 'What is the sac file name?'
c     read(stdin,*) seisfile
      
      call rsac1(seisfile,seis,ntpts,or_beg,dt,maxtpts,nerr)
      write(stdout,*) seisfile
      if(nerr .gt.0)then
        write(stdout,*) 'Problem reading in the seismogram.'
	stop
      end if
      
*     write(stdout,*) 'What is the source-receiver distance?'
*     read(stdin,*) distance
      call getfhv('DIST',distance,nerr)
*
      call getfhv('O',t0,nerr)
      call getfhv('A',a_pick,nerr)
*
      if(t0 .ne. -12345)then
         or_beg = or_beg - t0
      end if
      
      beg = 0.0
      end = dt * float(ntpts - 1)
      or_end = end + or_beg

      vgmax = 1e6
      vgmin = 0
      if(or_beg .gt. 0)then
        vgmax = distance / or_beg
      end if

      if(or_end .gt. 0)then
        vgmin = distance / or_end
      end if
      
      
      return
      end
      
