*
      subroutine sphs_match(s0,mx,nt,dt,p,v,np,dist,ts,ibatch)
      real s0(mx), p(np),v(np),dt,dist,f(128),f0,u(128),ts
      integer nt, np, ibatch
*
      integer nfpts,halfpts,nyqpt,forward,inverse
      integer pgopen, stdin, stdout, mxpts
*
      parameter(mxpts = 8192 + 2)
      real fnyquist, df, wwidth, tfraction, s(mxpts)
      
      character*1 key
*       
      forward =  1
      inverse = -1 
      stdin = 5
      stdout = 6  
*       
      wwidth = 200.0 
      tfraction = 0.2
*       
      twopi = 2.0 * acos(-1.0)
      pi_over_2 = 0.5 * acos(-1.0)
*       
       iblack = 0
       iwhite = 1
       ired = 2
       igreen = 3
       iblue = 4
       icyan = 5
       imagenta = 6
       iyellow = 7
       iorange = 8
       igreyel = 9
       igrecya = 10
       iblucya = 11
       iblumag = 12
       iredmag = 13
       idarkgray = 14
       ilightgray = 15
       
       isolid = 1
       
       phi0 = 0.0
*
*      select a window for the graphics output
*
       call pgqid(iold_dev)
       if(idev .eq. 0) idev = pgopen('/xwindow')
       call pgslct(idev)
*
*
*********************************************************************************
*     convert period to frequency
*********************************************************************************
*
      do 30 i = 1, np
        f(np - i + 1) = p(i)
	u(np - i + 1) = v(i)
30    continue
*
      call invert(f,np,forward)  
*
*********************************************************************************
*     Compute parameters for Fourier Transform
*********************************************************************************
      nfpts = 1
50    nfpts = nfpts * 2
      if(nfpts .lt. nt) go to 50
*      
      if(nfpts .gt. mxpts)then
	write(stdout,*)'Problem in sphs_match:'
	write(stdout,*)'Too many points in trace.'
	write(stdout,*)'  nfpts = ',nfpts,' mxpts = ',mxpts
	write(stdout,*)'RETURNING WITHOUT FILTERING'
	call pgslct(iold_dev)
	return
      end if
*
      halfpts = nfpts / 2
      fnyquist = 1 / (2*dt)
      nyqpt = halfpts
      df = 1.0 / (nfpts * dt)
*
*********************************************************************************
*     this is where the filtering loop starts
*      erase the window and plot the input time series
*********************************************************************************
*
10    continue
*
*********************************************************************************
*
*     copy the input seis into the work array
*
      call copy_seis(s,s0,nfpts)
*   
*********************************************************************************
*
*      set up some graphics
*
       call pgeras
*       
       xmin  = 0.0
       xmax  = nt*dt  
       call getabsmax(s,nfpts,sabsmax)
       ymin  = -2.1 * sabsmax
       ymax  = -ymin
       write(6,*)'sabsmax,ymin,ymax ',sabsmax,ymin,ymax
*       
       call pgsvp(0.1,0.9,0.1,0.45)
       call pgswin(xmin,xmax,ymin,ymax)
       call plt_seis(s,nt,0.0,dt,sabsmax)
       call pgbox('ABCTNS',0,0,'ABCTNSV',0,0)
       call pgmtext('B',2.5,0.5,0.5,'Time (s)')
       call pgmtext('T',0.5,0.5,0.5,
     &              'Original and Match-Filtered Seismograms')
*
*********************************************************************************
*     Transform the original time series
*********************************************************************************
      call realft(s,halfpts,forward)
      scalefactor = dt
      do 60 i = 1, nfpts
        s(i) = s(i) * scalefactor
60    continue
*
*********************************************************************************
*
*    phase shift the seismogram (filter with group delay)
*
      phi = phi0
      t0 = (real(nfpts) * dt) * 0.5 - ts
      do 70 k = 2, halfpts 
	j  = k*2
	f0 = (k-1) * df
*
*       interpolate the group velocity
*
	i = 0
65      continue
        i = i + 1	
	if( f0 .gt. f(i) .and. i .lt. np) go to 65
	
	if(i .gt. 1 .and. i .lt. np)then
	 vg = u(i) + (f0-f(i))*(u(i+1) - u(i))/(f(i+1) - f(i))
	else if(i .eq. 1)then
	 vg = u(1)
	 vg = 1e9
	else
	 vg = 1e9
	end if
*
*       construct the filter
*
	tg = dist / vg
	
	phi = phi + (twopi * df) * tg
*
	phi_middle = twopi * f0 * t0
*
	c = cos(-(phi + phi_middle))
	d = sin(-(phi + phi_middle))
*
*       (a+ib)(c+id) = ac - bd + i(ad + bc)
*
         a = s(j-1) 
         b = s(j)
*
	 s(j-1) = a * c - b * d
	 s(j)   = a * d + b * c
	 
70     continue 
*              
*********************************************************************************
*
       call realft(s,halfpts,inverse)
*
       scalefactor = 2.0 * df
       do 75 i = 1, nfpts
        s(i) = s(i) * scalefactor
75     continue
*
      call getabsmax(s,nfpts,absmax)

      duration = nfpts * dt
      half_duration = 0.5 * duration
      tleft = -2.0 * wwidth
      if(tleft .lt. -half_duration)tleft = -half_duration
      tright = tleft + 4*wwidth
      if(tright .gt. duration) tright = duration
      ymin = -1.05 * absmax
      ymax =  1.05 * absmax
      call pgswin(tleft,tright,ymin,ymax)
      call pgsvp(0.1,0.9,0.6,0.95)
      call plt_seis(s,nt,-half_duration,dt,0.0)
      call pgbox('ABCTNS',0,0,'ABCTNSV',0,0)
      call pgmtext('T',0.5,0.5,0.5,
     &              'Phase-Shifted and Windowed Seismograms')
       
*
*      cosine window the phase-shifted time series
*
      w1 = 0.5*(duration - wwidth)
      w2 = w1 + tfraction * wwidth
      w4 = 0.5*(duration + wwidth)
      w3 = w4 - tfraction * wwidth
      w2mw1 = w2 - w1
      w4mw3 = w4 - w3
      
      call pgsave
      call pgsci(igrecya)
      call pgmove(w1-half_duration,0.0)
*      
      do 80 i = 1, nfpts
*
         t = (i-1) * dt
*
	 taper = 1.0
*
	 if(t .lt. w1 .or. t .gt. w4) taper = 0.0
*
	 if(t .ge. w1 .and. t .le. w2)then
	    taper = cos(pi_over_2 * (w2-t)/w2mw1 )
	 end if
*
	 if(t .ge. w3 .and. t .le. w4)then
	    taper = cos(pi_over_2 * (t-w3)/w4mw3 )
	 end if
	 
	 if(t .ge. w1 .and. t .le. w4) then
	    call pgdraw(t-half_duration,taper)
	 end if
*	 
	 s(i) = s(i) * taper
*	 
80    continue

       call pgunsa
*
       call pgsave
       call pgsci(iblucya)
       call plt_seis(s,nt,-half_duration,dt,0.0)
       call pgunsa
*
*********************************************************************************
*
*    phase shift the seismogram back (filter with -group delay)
*
*
*     Transform the original windowed time series
*
      call realft(s,halfpts,forward)
      scalefactor = dt
      do 160 i = 1, nfpts
        s(i) = s(i) * scalefactor
160   continue
*
      phi =  phi0
      t0  = -t0
      do 170 k = 2, halfpts 
	j = k*2
	f0 = (k-1) * df
*
*       interpolate the group velocity
*
	i = 0
165     continue
        i = i + 1	
	if( f0 .gt. f(i) .and. i .lt. np) go to 165
	
	if(i .gt. 1 .and. i .lt. np)then
	 vg = u(i) + (f0-f(i))*(u(i+1) - u(i))/(f(i+1) - f(i))
	else if(i .eq. 1)then
	 vg = u(1)
	 vg = 1e9
	else
	 vg = 1e9
	end if
*
*       construct the filter
*
	tg =  -dist / vg
	phi = phi + twopi * df * tg
	phi_middle = twopi * f0 * t0
*
	c = cos(-(phi + phi_middle))
	d = sin(-(phi + phi_middle))
*
*       (a+ib)(c+id) = ac - bd + i(ad + bc)
*
         a = s(j-1) 
         b = s(j)
*
	 s(j-1) = a * c - b * d
	 s(j)   = a * d + b * c
	 
170    continue 
*              
       call realft(s,halfpts,inverse)
*
       scalefactor = 2.0 * df
       do 200 i = 1, nfpts
        s(i) = s(i) * scalefactor
200    continue
*	     
       ymin  = -2.05 * sabsmax
       ymax  = -ymin
       call pgswin(xmin,xmax,ymin,ymax)
       call pgsvp(0.1,0.9,0.1,0.45)
       call pgswin(xmin,xmax,ymin,ymax)
       call pgsave
       call pgsci(iblucya)
       call plt_seis(s,nt,0.0,dt,-sabsmax)
       call pgunsa
*
*    Print out the menu
*
      call match_menu()
*
*     if the input argument ibatch is 1, then skip
*       the menu
*      
      if(ibatch .eq. 1) go to 999
*
*     start of the menu loop
900   continue
*
      write(stdout,902)
902   format('Enter your choice: ',$)
905   read(stdin,'(a1)',err=905) key
*
      if(key .eq. 'm' .or. key .eq. 'M')then
	call match_menu()
      end if
*
      if(key .eq. 'w' .or. key .eq. 'W')then
        write(stdout,*)'Current width is ',wwidth
        write(stdout,915)
915     format('Enter new width value: ',$)
920     read(stdin,*,err=920) wwidth
	go to 10
      end if
*
      if(key .eq. 'f' .or. key .eq. 'F')then
        write(stdout,*)'Current taper fraction is ',tfraction
        write(stdout,925)
925     format('Enter new taper fraction value: ',$)
930     read(stdin,*,err=930) tfraction
	if(tfraction .lt. 0) tfraction = 0.0
	if(tfraction .gt. 0.5) tfraction = 0.5
	go to 10
      end if
*
      if(key .eq. 'b' .or. key .eq. 'B') go to 999
*
      go to 900
*
*     end of the menu loop
*
999   continue
*
      call pgslct(iold_dev)     
*
*     copy the filtered seis into the original
*
      call copy_seis(s0,s,nfpts)
*
      return
      end
*********************************************************************************
*********************************************************************************
*********************************************************************************
*********************************************************************************
*
*     convert from log10 and invert each element
*      
*********************************************************************************
      subroutine invert(x,n,iflag)
*********************************************************************************
      real x(n)
      integer n
      do 1 i = 1,n
        if(x(i) .eq. 0.0) return
        if(iflag .eq. 1) then
	  x(i) = 10.0**x(i)
	  x(i) = 1.0 / x(i)
	else
	  x(i) = 1.0 / x(i)
	  x(i) = log10(x(i))
	end if
1     continue

      return
      end
*********************************************************************************
*********************************************************************************
*********************************************************************************
*********************************************************************************
*
*     plot a time series
*      
*********************************************************************************
      subroutine plt_seis(s,n,b,dt,yoffset)
      real s(n), b
*     
      call pgmove(b,s(1)+yoffset)
      do 1 i = 2, n
        t = b + (i-1) * dt
	call pgdraw(t,s(i)+yoffset)
1     continue
*
      return
      end
*********************************************************************************
*********************************************************************************
*********************************************************************************
*********************************************************************************
*
*     get absolute max value
*      
*********************************************************************************
      subroutine getabsmax(s,n,absmax)
      real s(n), absmax
*     
      absmax = -1e9
      do 1 i = 1, n
        absmax = MAX(abs(s(i)),absmax)
1     continue
*
      return
      end

*********************************************************************************
*********************************************************************************
*********************************************************************************
*
*     copy values from the y into x
*
*********************************************************************************
      subroutine copy_seis(x,y,n)
      real x(n),y(n)
      integer n
*     
      do 1 i = 1, n
        x(i) = y(i)
1     continue
*
      return
      end
*********************************************************************************
*********************************************************************************
*********************************************************************************
*
*     print the menu to the screen
*
*********************************************************************************
      subroutine match_menu()
      integer stdin, stdout
      stdin = 5
      stdout = 6
      write(stdout,100) ' '
      write(stdout,100)'**************** MATCH **********************'
      write(stdout,100)'Phase-Match MENU: '
      write(stdout,100)'m = list this menu'
      write(stdout,100)'w = change window width'
      write(stdout,100)'f = change window taper fraction'
      write(stdout,100)'b = go back to main program'
      write(stdout,100)'*********************************************'
      write(stdout,100) ' '
100   format(a)
      return
      end
