c
c       input values are pairs (x,y)
c       output values are in 
c-----
c	CHECK look at the interpolator code - it does bad
c	thinbs as an extrapolator for the x > xmax
c	probably needs an if statement corrected
c----
c-----
c	The initial unequally spaced data is given as
c	y(x) x where Y and x are arrays
c	The c() are the necessary spline coefficients
c	yf is the array of interpolated values
c-----

        subroutine spline_it(x,y,use_it,n,nbp,ys)
c
        real x(n), y(n), ys(n)
        integer n, use_it(n)
	parameter(NP2=513)
c	
	real*4 xf(NP2), yf(NP2),c(NP2)
	common/bsp/b(NP2),q(4),h
c
        n_used = 0
        nfd = 0
c
        do 1 i = 1, NP2
           xf(i) = 0.0
           yf(i) = 0.0
           c(i) = 0.0
           b(i) = 0.0
1       continue
c      
        do 2 i = 1, n
           if(use_it(i) .eq. 1)then
             n_used = n_used + 1
             xf(n_used) = x(i)
             yf(n_used) = y(i)
          end if
2       continue

	call spline(xf,yf,c,n_used,nbp)
	
	call bfit(xf,yf,c,n_used,nfd)

        n_used = 0
        do 5 i = 1, n
           if(use_it(i) .eq. 1)then
             n_used = n_used + 1
             ys(i) = yf(n_used)
          end if
5       continue

        return
	end

	

	subroutine bfit(x,y,c,m,nfd)
c-----
c	use spline coefficients to define
c	fit to data
c
c	x	- array of abscissae
c	y	- array to be filled at x values
c	c	- array of spline coefficients
c	m	- number of points in spline
c	nfd	- 0 evaluate spline value at a point
c		- 1 estimate derivative at point
c		- 2 estimate integral at point
c-----
	parameter(NP2=513)
	dimension x(NP2),y(NP2),c(NP2)
	common/bsp/b(NP2),q(4),h
c-----
c	definition of arithmetic statement functions
c-----
        p1(t)=.25*t**2*t
        p2(t)=-(1.-t)**2*(1.+t)*.75+1.
        cp1(t)=t**4/16.
        cp2(t)=t*(1./4.+t*(3./8.+t*(1./4.-3./16.*t)))
        dp1(t)=.75*t**2
        dp2(t)=.75+t*(1.5-2.25*t)
c-----
c	begin processing
c-----
        sum=0.
        suma=0.
        ifl=0
        jt=1
        do 110 i=1,m
   80    if(x(i).le.b(jt+1)) go to 90
         if(nfd.ge.2) then
          ifl=0
          fa=-(c(jt)+11.*c(jt+1))*h/16.
          fb=(11.*c(jt+2)+c(jt+3))*h/16.
          sum=sum+fb-fa
         endif
         jt=jt+1
         go to 80
   90    u=(x(i)-b(jt))/h
         if(nfd.ne.1 .and. nfd.ne.2)then
           q(1)=p1(1.-u)
           q(2)=p2(1.-u)
           q(3)=p2(u)
           q(4)=p1(u)
         elseif(nfd .eq. 1)then
           q(1)=-dp1(1.-u)/h
           q(2)=-dp2(1.-u)/h
           q(3)=dp2(u)/h
           q(4)=dp1(u)/h
         elseif(nfd .eq. 2)then
           if(ifl.ne.1) then
             ifl=1
             fa=-(c(jt)+11.*c(jt+1))*h/16.
             suma=sum-fa
           endif
           q(1)=-cp1(1.-u)*h
           q(2)=-cp2(1.-u)*h
           q(3)=cp2(u)*h
           q(4)=cp1(u)*h
          endif
          
           yfit=0.0
           
           do 100 l=1,4
             ic=jt-1+l
             yfit=yfit+c(ic)*q(l)
  100      continue
  
           y(i)=yfit+suma
           
  110   continue
	return
	end

	subroutine spline(x,y,c,m,nbp)
c-----
c	x	- R*4	array of abscissa
c	y	- R*4	array of ordinates
c	c	- R*4	array of cubic spline coefficients
c	m	- I*4	number of points in data
c	nbp	- I*4	number of break points, e.g., 2 = one spline
c			segment used, 3 = two segments
c-----
	parameter(NP=1024,NP2=513)
	dimension x(NP2),y(NP2),g(NP2,6),c(NP2)
	common/bsp/b(NP2),q(4),h
c-----
c	arithmetic statment functions
c-----
	p1(t)=.25*t**2*t
	p2(t)=-(1.-t)**2*(1.+t)*.75+1.
c-----
c	begin processing
c-----
       zero=0.0
       mdg=NP2
       nband=4
c-----
c	safety check on the number of spline segments
c-----
       if(nbp.gt.m-2) nbp=m-4
       if(nbp.lt.2) nbp=2
       nc=nbp+2
       b(1)=x(1)
       b(nbp)=x(m)
       h=(b(nbp)-b(1))/float(nbp-1)
       if(nbp.gt.2) then
         do 20 i=3,nbp
           b(i-1)=b(i-2)+h
   20    continue
       endif
       ir=1
       ip=1
       i=1
       jt=1
  40   mt=0
  
  50   continue
  
       if(x(i).gt.b(jt+1)) go to 60
       u=(x(i)-b(jt))/h
       ig=ir+mt
       g(ig,1)=p1(1.-u)
       g(ig,2)=p2(1.-u)
       g(ig,3)=p2(u)
       g(ig,4)=p1(u)
       g(ig,5)=y(i)
       mt=mt+1
       
       if(i.eq.m) go to 60
       
       i=i+1
       
       go to 50
       
  60   continue
  
       call bndacc(g,mdg,nband,ip,ir,mt,jt)
       
       if(i.eq.m) go to 70
       
       jt=jt+1
       
       go to 40
       
  70   continue
  
       call bndsol(1,g,mdg,nband,ip,ir,c,nc,rnorm)
       return
       end

      subroutine bndacc(g,mdg,nb,ip,ir,mt,jt)
c-----
c     c.l. lawson and r.j. hanson, jet propulsion laboratory
c       sequential algorithm for banded least squares problem.
c     accumulation phase.   for solution phase use bndsol.
c
c     the calling program must set ir=1 and ip=1 before the
c       first call to bndacc for a new case.
c
c     the second subscript of g() must be dimensioned at least
c       nb+1 in the calling program.
c-----
      parameter(NP=1024,NP2=513)
      dimension g(NP2,6)
      zero=0.
      nbp1=nb+1
      if(mt.le.0) return
      if(jt.eq.ip) go to 70
      if(jt.le.ir) go to 30
      do 10 i=1,mt
      ig1=jt+mt-i
      ig2=ir+mt-i
      do 10 j=1,nbp1
  10  g(ig1,j)=g(ig2,j)
      ie=jt-ir
      do 20 i=1,ie
      ig=ir+i-1
      do 20 j=1,nbp1
  20  g(ig,j)=zero
      ir=jt
  30  mu=min0(nb-1,ir-ip-1)
      if(mu.eq.0) go to 60
      do 50 l=1,mu
      k=min0(l,jt-ip)
      lp1=l+1
      ig=ip+l
      do 40 i=lp1,nb
      jg=i-k
  40  g(ig,jg)=g(ig,i)
      do 50 i=1,k
      jg=nbp1-i
  50  g(ig,jg)=zero
  60  ip=jt
  70  mh=ir+mt-ip
      kh=min0(nbp1,mh)
      do 80 i=1,kh
      call h12(1,i,max0(i+1,ir-ip+1),mh,g(ip,i),
     $           1,rho,g(ip,i+1),1,mdg,nbp1-i)
   80 continue
      ir=ip+kh
      if(kh.lt.nbp1) go to 100
      do 90 i=1,nb
  90  g(ir-1,i)=zero
 100  continue
      return
      end

      subroutine bndsol(mode,g,mdg,nb,ip,ir,x,n,rnorm)
c-----
c     c.l. lawson and r.j. hanson, jet propulsion laboratory
c     sequential solution of a banded least squares problem.
c     solution phase.  for the accumulation phase us bndacc.
c
c     the second subscript of g() must be dimensioned at
c     least nb+1 in the calling program
c-----
	parameter (LIN=5,LOT=6,LER=0)
      parameter(NP=1024,NP2=513)
      dimension g(NP2,6),x(NP2)
      zero=0.
      rnorm=zero
      go to (10,90,50), mode
  10  do 20 j=1,n
  20  x(j)=g(j,nb+1)
      rsq=zero
      np1=n+1
      irm1=ir-1
      if(NP1.gt.irm1) go to 40
      do 30 j=np1,irm1
  30  rsq=rsq+g(j,nb+1)**2
      rnorm=sqrt(rsq)
  40  continue
  50  do 80 ii=1,n
      i=n+1-ii
      s=zero
      l=max0(0,i-ip)
      if(i.eq.n) go to 70
      ie=min0(n+1-i,nb)
      do 60 j=2,ie
      jg=j+l
      ix=i-1+j
  60  s=s+g(i,jg)*x(ix)
  70  if(g(i,l+1)) 80,130,80
  80  x(i)=(x(i)-s)/g(i,l+1)
      return
  90  do 120 j=1,n
      s=zero
      if(j.eq.1) go to 110
      i1=max0(1,j-nb+1)
      i2=j-1
      do 100 i=i1,i2
      l=j-i+1+max0(0,i-ip)
 100  s=s+x(i)*g(i,l)
 110  l=max0(0,j-ip)
      if(g(j,l+1)) 120,130,120
 120  x(j)=(x(j)-s)/g(j,l+1)
      return
 130  write(LOT,*)'zero diagonal term in bndsol'
c-----
c     cleanup
c-----
c-----
c     terminate program
c-----
      stop
      end

      subroutine h12 (mode,lpivot,l1,m,u,iue,up,c,ice,icv,ncv)
c-----
c     construction and/or application of a single
c     householder transformation..     q = i+u*(u**t)/b
c
c     mode    = 1 or 2   to select algorithm h1 or h2.
c     lpivot is the index of the pivot element.
c     l1,m   if l1 .le. m   the transformation will be constructed to
c            zero elements indexed from l1 through m.   if l1 gt. m
c            the subroutine does an identity transformation.
c     u(),iuw,up    on entry to h1 u() contains the pivot vector.
c                   iue is the storage increment between elements.
c                                       on exit from h1 u() and up
c                   contain quantities defining the vector u of the
c                   householder transformation.   on entry to h2 u()
c                   and up should contain quantities previously computed
c                   by h1.  these will not be modified by h2.
c     c()    on entry to h1 or h2 c() contains a matrix which will be
c            regarded as a set of vectors to which the householder
c            transformation is to be applied.  on exit c() contains the
c            set of transformed vectors.
c     ice    storage increment between elements of vectors in c().
c     icv    storage increment between vectors in c().
c     ncv    number of vectors in c() to be transformed. if ncv .le. 0
c            no operations will be done on c().
c-----
      parameter(NP=1024,NP2=513)
      dimension u(iue,m),c(5*NP2)
      double precision sm,b
      one=1.
c
      if (0.ge.lpivot.or.lpivot.ge.l1.or.l1.gt.m) return
      cl=abs(u(1,lpivot))
      if (mode.eq.2) go to 60
c            ****** construct the transformation. ******
          do 10 j=l1,m
  10      cl=amax1(abs(u(1,j)),cl)
      if (cl) 130,130,20
  20  clinv=one/cl
      sm=(dble(u(1,lpivot))*clinv)**2
          do 30 j=l1,m
  30      sm=sm+(dble(u(1,j))*clinv)**2
c             convert dble. prec. sm to sngl. prec. sm1
      sm1=sm
      cl=cl*sqrt(sm1)
      if (u(1,lpivot)) 50,50,40
  40  cl=-cl
  50  up=u(1,lpivot)-cl
      u(1,lpivot)=cl
      go to 70
c     ****** apply the transformation 1+u*(u**t)/b to c. ******
c
  60  if (cl) 130,130,70
  70  if (ncv.le.0) return
      b=dble(up)*u(1,lpivot)
c          b  must be nonpositive here.  if b=0., return.
c
      if (b) 80,130,130
  80  b=one/b
      i2=1-icv+ice*(lpivot-1)
      incr=ice*(l1-lpivot)
          do 120 j=1,ncv
          i2=i2+icv
          i3=i2+incr
          i4=i3
          sm=c(i2)*dble(up)
              do 90 i=l1,m
              sm=sm+c(i3)*dble(u(1,i))
  90          i3=i3+ice
          if (sm) 100,120,100
 100      sm=sm*b
          c(i2)=c(i2)+sm*dble(up)
              do 110 i=l1,m
              c(i4)=c(i4)+sm*dble(u(1,i))
 110          i4=i4+ice
 120      continue
 130      return
          end
	
